app/models.py
from flask_login import UserMixin
from werkzeug.security import generate_password_hash, check_password_hash

from app import db, login_manager


class User(UserMixin, db.Model):
    """Create an User table"""
    __tablename__ = 'users'

    id = db.Column(db.Integer, primary_key=True)
    email = db.Column(db.String(60), unique=True)
    first_name = db.Column(db.String(60))
    last_name = db.Column(db.String(60))
    password_hash = db.Column(db.String(128))
    is_admin = db.Column(db.Boolean, default=False)

    @property
    def password(self):
        """Prevent pasword from being accessed"""
        raise AttributeError('password is not a readable attribute.')

    @password.setter
    def password(self, password):
        """Create hashed password."""
        self.password_hash = generate_password_hash(password)

    def verify_password(self, password):
        """Check if hashed password matches actual password"""
        return check_password_hash(self.password_hash, password)

    def __repr__(self):
        return f'<User({self.first_name}, {self.last_name})>'


# Set up user_loader
@login_manager.user_loader
def load_user(user_id):
    return User.query.get(int(user_id))

app/__init__.py
from flask import Flask
from flask_sqlalchemy import SQLAlchemy
from flask_login import LoginManager
from flask_migrate import Migrate
from flask_bootstrap import Bootstrap

# local imports
from config import app_config

# db variable initialization
db = SQLAlchemy()
login_manager = LoginManager()


def create_app(config_name):
    app = Flask(__name__, instance_relative_config=True)
    app.config.from_object(app_config[config_name])
    app.config.from_pyfile('config.py')

    Bootstrap(app)
    db.init_app(app)

    login_manager.init_app(app)
    login_manager.login_message = "You must be logged in to access this page."
    login_manager.login_view = "auth.login"
    migrate = Migrate(app, db)

    from app import models

    from .auth import auth as auth_blueprint
    app.register_blueprint(auth_blueprint)

    from .home import home as home_blueprint
    app.register_blueprint(home_blueprint)

    return app

app/home/__init__.py
from flask import Blueprint

home = Blueprint('home', __name__)

from . import views

app/home/views.py
from flask import flash, redirect, render_template, url_for, request, send_file, current_app
from flask_login import login_required, login_user, logout_user
import requests
import aiohttp
import asyncio
import json
import time
import os

from . import home
from .. import db
from ..models import User


@home.route('/')
def homepage():
    """Manage the / route"""
    return render_template('home/index.html', title="Welcome")


@home.route('/dashboard')
@login_required
def dashboard():
    """Manage the /dashboard route"""
    users_list = db.session.query(User).all()
    return render_template('home/dashboard.html', title="Dashboard", users_list=users_list)


@home.route('/add_user', methods=['POST'])
def add_user():

    is_admin = False
    if len(request.form['rights']) > 0 and request.form['rights'] == '1':
        is_admin = True

    user = User(
        email=request.form['email'],
        first_name=request.form['first_name'],
        last_name=request.form['last_name'],
        password=request.form['password'],
        is_admin=is_admin
    )

    # add user to the database
    db.session.add(user)
    db.session.commit()

    flash('You have successfully added user.')
    return redirect(url_for('home.dashboard'))


@home.route('/delete/<int:id>', methods=['GET'])
@login_required
def delete_user(id):
    user = db.session.query(User).filter(User.id == id)
    user.delete()
    db.session.commit()

    flash('User removed successfully')

    return redirect(url_for('home.dashboard'))


@home.route('/edit/<int:id>', methods=['GET'])
@login_required
def get_user(id):

    user = db.session.query(User).where(User.id == id).first()

    return render_template('/home/edit.html', user=user, title='Edit user')


@home.route('/update/<int:id>/', methods=['POST'])
@login_required
def update_user(id):

    email = request.form['email']
    first_name = request.form['first_name']
    last_name = request.form['last_name']
    is_admin = bool(int(request.form['rights']))

    db.engine.execute(f"UPDATE users SET "
                      f"email = '{email}', "
                      f"first_name = '{first_name}', "
                      f"last_name = '{last_name}',"
                      f"is_admin = {is_admin} WHERE id = {id}")

    flash('You have successfully updated user.')
    return redirect(url_for('home.dashboard'))


async def get(url):
    try:
        async with aiohttp.ClientSession() as session:
            async with session.get(url) as response:
                data = await response.read()
                return json.loads(data)
    except:
        pass


@home.route('/asynchronous')
def asynchronous():
    start_time = time.time()

    loop = asyncio.new_event_loop()
    asyncio.set_event_loop(loop)

    url_list = ['http://localhost:5000/json/file_1.json',
                'http://localhost:5000/json/file_2.json',
                'http://localhost:5000/json/file_3.json']

    coroutines = [get(url) for url in url_list]

    result = loop.run_until_complete(asyncio.gather(*coroutines))
    sorted_result = sort_received_result(result)

    spend_time = f'--- {time.time() - start_time} seconds ---'

    return render_template('/home/json_result.html', result=sorted_result, spend_time=spend_time)


@home.route('/synchronous')
def synchronous():
    start_time = time.time()

    url_list = ['http://localhost:5000/json/file_1.json',
                'http://localhost:5000/json/file_2.json',
                'http://localhost:5000/json/file_3.json']

    result = [requests.get(url).json() for url in url_list]
    sorted_result = sort_received_result(result)

    spend_time = f'--- {time.time() - start_time} seconds ---'

    return render_template('/home/json_result.html', result=sorted_result, spend_time=spend_time)


@home.route('/json/<path:path>')
def get_json_file(path):
    with current_app.open_resource(f'static/json/{path}') as f:
        return f.read()


def sort_received_result(result: list) -> list:

    result_list = []
    for list in result:
        result_list += list

    return sorted(result_list, key=lambda i: i['id'])

app/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <title>{{ title }}</title>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <link href="{{ url_for('static', filename='css/style.css') }}" rel="stylesheet">
</head>
<body>
    <nav class="navbar navbar-default navbar-fixed-top" role="navigation">
        <div class="container">
          <div class="collapse navbar-collapse">
              <ul class="nav navbar-nav navbar-right">
                {% if current_user.is_authenticated %}
                  <li><a href="{{ url_for('home.dashboard') }}">Dashboard</a></li>
                  <li><a href="{{ url_for('auth.logout') }}">Logout</a></li>
                {% else %}
                  <li><a href="{{ url_for('home.homepage') }}">Home</a></li>
                  <li><a href="{{ url_for('auth.login') }}">Login</a></li>
                {% endif %}
              </ul>
          </div>
        </div>
    </nav>
    {% block body %}
    {% endblock %}

<script src="{{url_for('static', filename='js/main.js')}}"></script>
</body>
</html>

app/templates/home/dashboard.html
{% extends "base.html" %}
{% import "bootstrap/utils.html" as utils %}
{% block title %}Dashboard{% endblock %}
{% block body %}
<div class="dashboard-div">
    <h1>Dashboard</h1>

    {% with messages = get_flashed_messages()  %}
          {% if messages %}
              {% for message in messages %}
              <div class="alert alert-info" role="alert">
                    {{ message }}
              </div>
              {% endfor %}
          {% endif %}
    {% endwith %}

    {% if current_user.is_admin %}
    <div class="add_user_div">
        <form action="" id="add_user_form" class="form-inline">
            <input type="email" name="email" placeholder="email" required class="form-control">
            <input type="text" name="first_name" placeholder="first name" class="form-control">
            <input type="text" name="last_name" placeholder="last name" class="form-control">
            <input type="password" name="password" placeholder="password" required class="form-control">
            <select name="rights" id="" class="form-control">
                <option value="" hidden>User rights</option>
                <option value="1">All</option>
                <option value="0">View</option>
            </select>
            <br><br>
            <input type="submit" value="Add user" id="add_user_button" class="btn btn-primary">
        </form>
    </div>
    {% endif %}
    <table id="example" class="table table-striped table-bordered">
    <thead>
      <tr>
        <td>ID</td>
        <td>First name</td>
        <td>Last name</td>
        <td>Email</td>
        <td>Rights</td>
        {% if current_user.is_admin %}
        <td>Action</td>
        {% endif %}
      </tr>
    </thead>
    <tbody>
      {% for user in users_list %}
      <tr>
        <td>{{user.id}}</td>
        <td>{{user.first_name}}</td>
        <td>{{user.last_name}}</td>
        <td>{{user.email}}</td>
        {% if user.is_admin %}
        <td>All</td>
        {% else %}
        <td>View</td>
        {% endif %}
        {% if current_user.is_admin %}
        <td width="130">
          <a href="/edit/{{user.id}}">edit</a> /
          <a href="/delete/{{user.id}}">delete</a>
        </td>
        {% endif %}
      </tr>
      {% endfor %}
    </tbody>
</table>
</div>
{% endblock %}

app/templates/home/edit.html
{% extends "base.html" %}
{% block body %}
  <div class="row edit_div">
        <form action="/update/{{user.id}}" method="POST">
          <div class="form-group">
            <input type="text" name="first_name" value="{{user.first_name}}" class="form-control">
          </div>
          <div class="form-group">
            <input type="text" name="last_name" value="{{user.last_name}}" class="form-control">
          </div>
          <div class="form-group">
            <input type="text" name="email" value="{{user.email}}" class="form-control">
          </div>
            <div class="form-group">
            <select name="rights" id="" class="form-control">
                <option value="" hidden>User rights</option>
                <option value="1">All</option>
                <option value="0">View</option>
            </select>
          </div>
          <div class="form-group">
            <button type="submit" class="btn btn-primary btn-block">
              Update
            </button>
          </div>
        </form>
  </div>
{% endblock %}

app/templates/home/index.html
<!-- app/templates/home/index.html -->

{% extends "base.html" %}
{% block title %}Home{% endblock %}
{% block body %}
<div class="home-div">
    <h1>Home Page</h1>
</div>
{% endblock %}

app/templates/home/json_result.html
{% for row in result %}
    {{ row }} <br>
{% endfor %}
<br>
<br>
<b>{{ spend_time }}</b>